/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*   A l'occasion des 48h Casio Programming Contest #12          */
/*                                                               */
/*   Space Invader                                               */
/*                                                               */
/*   Auteur       LePhenixNoir                                   */
/*   Date         28/02/2014                                     */
/*   Description  Conquete de l'espace --                        */
/*                Vous envahissez un systeme solaire             */
/*   Fichiers     SpaceInv.c - Programme principal               */
/*                memory.c   - Bibliotheque de gestion memoire   */
/*                game.c     - Fonctions des systeme et map      */
/*                menu.c     - Menu principal                    */
/*                story.c    - Sequences histoire et sauvegardes */
/*                                                               */
/*****************************************************************/

#include "fxlib.h"
#include "SpaceInv.h"

unsigned int key;
unsigned int SaveData[10];

int AddIn_main(int isAppli, unsigned short OptionNum)
{
  int x;
  CPC();

  while(1) switch(Menu())
  {
    case 0: NewGame();
    case 1: Load(); while((x=Space())+1) PlayLevel(x+1); break;
    case 2: Credits(); break;
  }

  return 1;
}

void Credits()
{
  Bdisp_AllClr_DDVRAM();
  locate(5,1); Print((const unsigned char *)"Space Invader");
  PrintMini( 8, 9,(const unsigned char *)"A l'occasion des 48h CPC #12",0);
  PrintMini( 2,24,(const unsigned char *)"Programmation",0);
  PrintMini(12,31,(const unsigned char *)"LePhenixNoir",0);
  PrintMini( 2,41,(const unsigned char *)"Credits graphiques",0);
  PrintMini(12,48,(const unsigned char *)"D'apres le travail original",0);
  PrintMini(12,55,(const unsigned char *)"de 'Shaber'",0);
  GetKey(&key);
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum) {
  return INIT_ADDIN_APPLICATION(isAppli, OptionNum); }
#pragma section

