#include "fxlib.h"
#include "SpaceInv.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern unsigned int key;
extern unsigned int SaveData[10];

void NewGame()
{
  int handle;
  int i;

  memory_deletefile("\\\\fls0\\SpaceInv.sav");
  memory_createfile("\\\\fls0\\SpaceInv.sav",16);
  memory_closefile(handle);
  for(i=0;i<4;i++) SaveData[i] = 0;
  Save();
}

void Tutoriel()
{
  SaveDisp(1);
  switch(SaveData[0])
  {
    case 0:
      Text("Voici le systeme solaire de","Ter-Ilis. Choisi ta cible","en utilisant \346\232 et \346\233, puis",
           "appuie sur [EXE] si","tu souhaites t'y rendre.","");
      Text("Appuie sur [ALPHA] pour","acceder au magsin.","","","","");
      SaveData[0] = 1;
      RestoreDisp(1);
      return;

     case 1:
      Text("Il faut que nous prenions","le controle de toutes les","planetes une a une.",
           "Pour cela, il faut que tu","les traverses sans te faire","prendre.");
      Text("Tu peux sauter sur les","plateformes, mais pas passer","a travers.","","","");
      Text("Les blocs marques d'une","croix sont des barrieres.","On ne peut pas les","passer.",
           "Quant aux pics, a ta place","je n'y toucherais pas !");
      Text("Et profites-en pour","recuperer le maximum de","pieces !",
           "Le nombre de pieces que tu","as recupere s'affiche en","haut a gauche de l'ecran.");
      SaveData[0] = 2;
      RestoreDisp(1);
      return;
  }
}

void Story()
{
  SaveDisp(1);
  switch(SaveData[1])
  {
    case 0:
      Text("Bonjour Wollaston !","Tu as ete choisi pour une","perilleuse mission :",
           "Tu dois envahir le systeme","solaire de l'infame Ter-Ilis.","");
      Text("Celui-ci se compose de 7","planetes.","Tu devras toutes les",
           "traverser une par une","pour atteindre ton but","ultime.");
      Text("Nous arrivons aux portes","du systeme.","Ta mission va bientot",
           "commencer.","","");
      SaveData[1] = 1; RestoreDisp(1); return;

    case 1:
      Text("Nous allons nous poser","sur Terra, notre","planete artificielle",
           "que nous avons amenee","pour l'occasion.","");
      RestoreDisp(1); return;

    case 2:
      Text("Voici Glaciaire, la plus","recente des planetes du","systeme.",
           "Elle vient d'un systeme","disparu.","");
      RestoreDisp(1); return;

    case 3:
      Text("Rocheuse est la 3eme","planete du systeme.","Tu risques d'y croiser",
           "pas mal de bloocs","incassables.","");
      RestoreDisp(1); return;

    case 4:
      Text("Comet, la 4eme planete","a subi l'impact d'un","asteroide il y a bien",
           "longtemps. Elle en porte","maintenant le marque","indelebile.");
      RestoreDisp(1); return;

    case 5:
      Text("Ce qu'on considere comme","la planete Xenon n'est","que le noyau d'une",
           "geante gazeuse.","Mettez bien vos masques","a gaz !");
      RestoreDisp(1); return;

    case 6:
      Text("Nous n'avons jamis su","expliquer comment Fractal","pouvait rester coherente",
           "malgre ses deux morceaux.","","");
      RestoreDisp(1); return;

    case 7:
      Text("La planete Dark etait","l'etoile du systeme","avant que Ter-Ilis vienne",
           "et qu'elle ne meure.","Aujourd'hui elle est","dure et froide.");
      RestoreDisp(1); return;

    case 8:
      Text("Bravo Wollaston !","Tu as mene a bien cette","mortelle quete et",
           "rendu un grand service","a notre nation !","");
      Text("Au fait, j'espere que","tu as bien pris toutes","les pieces ?",
           "Et que tu n'est jamais","mort ?","");
       SaveData[1]=9; RestoreDisp(1); return;
  }
}

void Cadre()
{
  const DISPBOX d = { 4,4,124,60 };
  Bdisp_AreaClr_VRAM(&d);

  Bdisp_DrawLineVRAM(6,3,6,5);
  Bdisp_DrawLineVRAM(3,6,5,6);
  Bdisp_DrawLineVRAM(3,4,3,6);
  Bdisp_DrawLineVRAM(4,3,6,3);
  Bdisp_SetPoint_VRAM(4,4,1);

  Bdisp_DrawLineVRAM(122,3,122,5);
  Bdisp_DrawLineVRAM(123,6,125,6);
  Bdisp_DrawLineVRAM(122,3,124,3);
  Bdisp_DrawLineVRAM(125,6,125,4);
  Bdisp_SetPoint_VRAM(124,4,1);

  Bdisp_DrawLineVRAM(3,58,5,58);
  Bdisp_DrawLineVRAM(6,59,6,61);
  Bdisp_DrawLineVRAM(3,58,3,60);
  Bdisp_DrawLineVRAM(6,61,4,61);
  Bdisp_SetPoint_VRAM(4,60,1);

  Bdisp_DrawLineVRAM(122,59,122,61);
  Bdisp_DrawLineVRAM(123,58,125,58);
  Bdisp_DrawLineVRAM(122,61,124,61);
  Bdisp_DrawLineVRAM(125,58,125,60);
  Bdisp_SetPoint_VRAM(124,60,1);

  Bdisp_DrawLineVRAM(4,6,4,58);
  Bdisp_DrawLineVRAM(6,4,122,4);
  Bdisp_DrawLineVRAM(6,60,122,60);
  Bdisp_DrawLineVRAM(124,6,124,58);
}

void Text(char *c1, char *c2, char *c3, char *c4, char *c5, char *c6)
{
  Cadre();
  PrintMini(8, 8,(const unsigned char *)c1,0);
  PrintMini(8,16,(const unsigned char *)c2,0);
  PrintMini(8,24,(const unsigned char *)c3,0);
  PrintMini(8,32,(const unsigned char *)c4,0);
  PrintMini(8,40,(const unsigned char *)c5,0);
  PrintMini(8,48,(const unsigned char *)c6,0);
  PrintMini(116,51,(const unsigned char *)"\346\235",0);
  GetKey(&key);
}

void Save()
{
  int handle;

  memory_deletefile("\\\\fls0\\SpaceInv.sav");
  memory_createfile("\\\\fls0\\SpaceInv.sav",16);
  handle = memory_openfile("\\\\fls0\\SpaceInv.sav",_OPENMODE_WRITE);
  memory_writefile(handle,(void *)SaveData,16);
  memory_closefile(handle);
}

void Load()
{
  int handle;

  handle = memory_openfile("\\\\fls0\\SpaceInv.sav",_OPENMODE_READ);
  if(handle<0) return;
  memory_readfile(handle,(void *)SaveData,16,-1);
  memory_closefile(handle);
}

void Shop()
{
  int p = 0;

  Bdisp_AllClr_DDVRAM();
  locate(8,1); Print((const unsigned char *)"Magasin");
  locate(4,3); Print((const unsigned char *)"Pieces 5");
  locate(4,4); Print((const unsigned char *)"Double Pieces");
  locate(4,5); Print((const unsigned char *)"Vitesse");
  locate(4,6); Print((const unsigned char *)"Saut");
  SaveDisp(1);

  while(1)
  {
    RestoreDisp(1);
    locate(2,p+3); Print((const unsigned char *)"\23");

    while(1)
    {
      GetKey(&key);
      if(key==30002) return;
      if(key==30004) { Item(p); break; }
      if(key==30018 && p) { p--; break; }
      if(key==30023 && p-3) { p++; break; }
    }
  }
}

void Item(int n)
{
  int p = 0;
  char ch[20];
  char *items[4] = { "Pieces 5","Double Pieces","Vitesse","Saut" };
  int  prices[4] = { 50,150,200,500 };

  Bdisp_AllClr_DDVRAM();
  sprintf(ch,"- %s -",items[n]);
  PrintXY(64-3*strlen(ch),1,(const unsigned char *)ch,0);

  switch(n)
  {
    case 0:
      PrintMini(5,15,(const unsigned char *)"Fait apparaitre des pieces",0);
      PrintMini(5,22,(const unsigned char *)"noires valant l'equivalent",0);
      PrintMini(5,29,(const unsigned char *)"de 5 pieces.",0);
      break;
    case 1:
      PrintMini(5,15,(const unsigned char *)"Double le nombre de pieces",0);
      PrintMini(5,22,(const unsigned char *)"gagnees si vous les ramassez",0);
      PrintMini(5,29,(const unsigned char *)"toutes (pieces 5 comprises)",0);
      break;
    case 2:
      PrintMini(5,15,(const unsigned char *)"Double votre vitesse.",0);
      PrintMini(5,22,(const unsigned char *)"Attention ! Cela rend le",0);
      PrintMini(5,29,(const unsigned char *)"jeu tres difficile.",0);
      break;
    case 3:
      PrintMini(5,15,(const unsigned char *)"Vous permet de sauter plus",0);
      PrintMini(5,22,(const unsigned char *)"haut !",0);
      break;
  }
  SaveDisp(2);

  if(SaveData[3] == (SaveData[3]|(1<<n))) { do GetKey(&key); while(key!=30002); RestoreDisp(1); return; }

  sprintf(ch,"Prix %d",prices[n]);
  PrintMini(15,42,(const unsigned char *)ch,0);
  sprintf(ch,"Pieces %d",SaveData[2]);
  PrintMini(69,42,(const unsigned char *)ch,0);
  SaveDisp(2);

  if(SaveData[2]<prices[n]) { do GetKey(&key); while(key!=30002); RestoreDisp(1); return; }

  locate(2,8); Print((const unsigned char *)"Acheter ?");
  locate(13,8); Print((const unsigned char *)"OUI  NON");
  SaveDisp(2);

  while(1)
  {
    RestoreDisp(2);
    locate(12+5*p,8); Print((const unsigned char *)"\346\233");
    while(1)
    {
      GetKey(&key);
      if(key==30002 || (key==30004 && p)) { RestoreDisp(1); return; }
      if(key==30004 && !p) { SaveData[2]-=prices[n]; SaveData[3] |= (1<<n); return; }
      if(key==30020 && p) { p--; break; }
      if(key==30021 && p-1) { p++; break; }
    }
  }
}
